/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_AGRDELIVERY                                              */
/* Tabela : AGRDELIVERY                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 08/10/2003 Mariana Costa                                                   */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_AGRDELIVERY
BEFORE INSERT OR UPDATE OR DELETE
ON AGRDELIVERY FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUAGRD := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.DSDELIVERY,0) <> NVL(:NEW.DSDELIVERY,0)) OR
         (NVL(:OLD.CDAGRDEL,0)   <> NVL(:NEW.CDAGRDEL,0)) THEN
         :NEW.DTULTATUAGRD := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('AGRDELIVERY', '', 'CDAGRDEL='||:OLD.CDAGRDEL||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE AGRDELIVERY MODIFY DTULTATUAGRD DEFAULT SYSDATE
/
