CREATE OR REPLACE TRIGGER USR_ATUALIZA_QTPROGENTAF_OL
BEFORE INSERT OR DELETE ON ITEMAUTF
FOR EACH ROW
DECLARE
  V_IDFUNCAOFILI     VARCHAR2(1);
  V_VRFATOCONVOL     FLOAT := 0;
  V_VRARREDCMPOL     FLOAT := 0;
  V_VRFATOCONVORIG   FLOAT := 0;
  V_QTSOLIPROD       FLOAT := 0;
  V_QTPROGENTAF      FLOAT := 0;
  V_CDPRODITMAP      ITMAPURPREC.CDPRODITMAP%TYPE;
  V_CDFORNECED       FORNECEDOR.CDFORNECED%TYPE;
  V_CDREGIAO         REGIAO.CDREGIAO%TYPE;
  V_CDFILCENTCMP     FILIAL.CDFILCENTCMP%TYPE;
  V_VRPRECUNIITM     ITEMCOLE.VRPRECUNIITM%TYPE;
  V_CDPRODUTOORIG    PRODUTO.CDPRODUTO%TYPE;
  V_CDOPERADOR       OPERADOR.CDOPERADOR%TYPE;
  V_IDPRCMPATIVO     VARCHAR2(1);
  V_CDPRODESTO       PRODUTO.CDPRODESTO%TYPE;
  V_NMOPERADOR       VARCHAR2(40);
  V_NRSEQITMAP       VARCHAR2(10);

BEGIN
   SELECT NVL(MAX(IDFUNCAOFILI), 'C'), NVL(MAX(CDREGIAO), 'C'), NVL(MAX(FILIAL.CDFILCENTCMP), MAX(FILIAL.CDFILIAL))
     INTO V_IDFUNCAOFILI, V_CDREGIAO, V_CDFILCENTCMP
     FROM FILIAL
    WHERE CDFILIAL = NVL(:NEW.CDFILDEST, :OLD.CDFILDEST);
   IF V_IDFUNCAOFILI = 'O' THEN
      IF INSERTING THEN
         SELECT
            NVL(MAX(PRODUTOOL.VRFATOCONV), 0), MAX(PRODUTO.CDPRODUTO), CASE NVL(MAX(PRODUTOOL.VRARREDCMP), 0)
                                                                          WHEN 0
                                                                          THEN 1
                                                                          ELSE NVL(MAX(PRODUTOOL.VRARREDCMP), 0)
                                                                       END, CASE NVL(MAX(PRODUTO.VRFATOCONV), 0)
                                                                               WHEN 0
                                                                               THEN 1
                                                                               ELSE NVL(MAX(PRODUTO.VRFATOCONV), 0)
                                                                            END
         INTO
            V_VRFATOCONVOL, V_CDPRODUTOORIG, V_VRARREDCMPOL, V_VRFATOCONVORIG
         FROM
            RELACPRODOL, PRODUTO, PRODUTO PRODUTOOL
         WHERE RELACPRODOL.CDPRODARVOL = :NEW.CDPRODUTO
           AND RELACPRODOL.CDMARCA     = :NEW.CDMARCA
           AND RELACPRODOL.CDPRARVORIG = PRODUTO.CDPRODUTO
           AND RELACPRODOL.CDPRODARVOL = PRODUTOOL.CDPRODUTO
           AND PRODUTO.CDPRODESTO      = PRODUTOOL.CDPRODESTO
           AND RELACPRODOL.CDPRARVORIG <> RELACPRODOL.CDPRODARVOL;
         IF ((V_VRFATOCONVOL > 0) AND (V_CDPRODUTOORIG <> :NEW.CDPRODUTO)) THEN
            SELECT MAX(CDFORNECED), MAX(NRSEQAPURAF)
              INTO V_CDFORNECED, V_NRSEQITMAP
              FROM AUTOFORNE
             WHERE CDFILDEST  = :NEW.CDFILDEST
               AND CDFILLANC  = :NEW.CDFILLANC
               AND NRAUTOFORN = :NEW.NRAUTOFORN;
            SELECT NVL(MIN(VRPRECUNIITM), 0)
              INTO V_VRPRECUNIITM
              FROM ITEMCOLE
             WHERE CDFILIAL   = V_CDFILCENTCMP
               AND CDMARCA    = :NEW.CDMARCA
               AND CDREGIAO   = V_CDREGIAO
               AND CDFORNECED = V_CDFORNECED
               AND CDPRODUTO  = :NEW.CDPRODUTO
               AND :NEW.DTENTRITMSOL BETWEEN DTINIVALITM  AND DTFINVALITM;
            SELECT NVL(MIN(QTSOLACOMP), 0)
              INTO V_QTPROGENTAF
              FROM ITMAPURPREC
             WHERE ITMAPURPREC.CDCENTITMAP  = V_CDFILCENTCMP
               AND ITMAPURPREC.NRSEQITMAP   = V_NRSEQITMAP
               AND ITMAPURPREC.CDREGITMAP   = V_CDREGIAO
               AND ITMAPURPREC.CDFORNITMAP  = V_CDFORNECED
               AND ITMAPURPREC.DTENTRAPUT   = :NEW.DTENTRITMSOL
               AND ITMAPURPREC.CDFILIAP     = :NEW.CDFILDEST
               AND ITMAPURPREC.CDPRODITMAP  = V_CDPRODUTOORIG
               AND ITMAPURPREC.CDMARCITMAP  = :NEW.CDMARCA
               AND ITMAPURPREC.IDITMSELAPUR = 'S';
            IF V_VRPRECUNIITM > 0 THEN
               V_QTPROGENTAF    := V_QTPROGENTAF*V_VRFATOCONVORIG;
               :NEW.QTPROGENTAF := CEIL(V_QTPROGENTAF/(V_VRFATOCONVOL*V_VRARREDCMPOL));
               :NEW.VRPREUNIAF  := V_VRPRECUNIITM;
               SELECT MAX(CDOPERADOR)
                 INTO V_CDOPERADOR
                 FROM AUTOFORNE
                WHERE CDFILDEST  = :NEW.CDFILDEST
                  AND CDFILLANC  = :NEW.CDFILLANC
                  AND NRAUTOFORN = :NEW.NRAUTOFORN;

               FOR C_ITEM IN (SELECT CDFILSOLI, CDFILLAN, NRSOLICMP, CDPRODUTO, DTPROGENTR
                                FROM ITEMSOLI
                               WHERE ITEMSOLI.CDFILSOLI  = :NEW.CDFILDEST
                                 AND ITEMSOLI.CDPRODUTO  = V_CDPRODUTOORIG
                                 AND ITEMSOLI.DTPROGENTR = :NEW.DTENTRITMSOL
                                 AND ROWNUM = 1) LOOP

                  BEGIN
                     INSERT
                       INTO ITEMSOLI (CDFILSOLI, CDFILLAN, NRSOLICMP, CDPRODUTO, DTPROGENTR, QTSOLIPROD,
                                      DTUTILIZA, IDITMCONS, TXOBSITMSOL, IDBAIXITMSOL, QTTRANSFSOL, NRLOTEESTQ,
                                      NRSUBLOTE, CDPRODPROD, CDFILLANCONS, CDFILSOLCONS, NRSOLCMPCONS,
                                      CDPRODUTCONS, DTPROGENCONS, CDMARCA)
                     SELECT CDFILSOLI, CDFILLAN, NRSOLICMP, :NEW.CDPRODUTO, DTPROGENTR, :NEW.QTPROGENTAF,
                            DTUTILIZA, IDITMCONS, TXOBSITMSOL, IDBAIXITMSOL, QTTRANSFSOL, NRLOTEESTQ,
                            NRSUBLOTE, CDPRODPROD, CDFILLANCONS, CDFILSOLCONS, NRSOLCMPCONS,
                            CDPRODUTCONS, DTPROGENCONS, CDMARCA
                       FROM ITEMSOLI
                      WHERE ITEMSOLI.CDFILSOLI  = C_ITEM.CDFILSOLI
                        AND ITEMSOLI.CDFILLAN   = C_ITEM.CDFILLAN
                        AND ITEMSOLI.NRSOLICMP  = C_ITEM.NRSOLICMP
                        AND ITEMSOLI.CDPRODUTO  = C_ITEM.CDPRODUTO
                        AND ITEMSOLI.DTPROGENTR = C_ITEM.DTPROGENTR;
                  EXCEPTION
                     WHEN OTHERS THEN BEGIN
                        UPDATE ITEMSOLI
                           SET QTSOLIPROD    = QTSOLIPROD + :NEW.QTPROGENTAF
                         WHERE ITEMSOLI.CDFILSOLI  = C_ITEM.CDFILSOLI
                           AND ITEMSOLI.CDFILLAN   = C_ITEM.CDFILLAN
                           AND ITEMSOLI.NRSOLICMP  = C_ITEM.NRSOLICMP
                           AND ITEMSOLI.CDPRODUTO  = :NEW.CDPRODUTO
                           AND ITEMSOLI.DTPROGENTR = C_ITEM.DTPROGENTR;
                     END;
                  END;
                  DELETE
                    FROM ITEMSOLI
                   WHERE ITEMSOLI.CDFILSOLI  = C_ITEM.CDFILSOLI
                     AND ITEMSOLI.CDFILLAN   = C_ITEM.CDFILLAN
                     AND ITEMSOLI.NRSOLICMP  = C_ITEM.NRSOLICMP
                     AND ITEMSOLI.CDPRODUTO  = C_ITEM.CDPRODUTO
                     AND ITEMSOLI.DTPROGENTR = C_ITEM.DTPROGENTR;

                  INSERT
                   INTO MOVOPSOL (CDFILSOLMOV, CDFILLANMOV, NRSOLIMOV, CDPRODUTO,
                                  DTENTROPER, DTOPERSOL, CDOPERADOR, QTANTOPER, QTDEPOPER,
                                  DSJUSTOPER)
                  VALUES (C_ITEM.CDFILSOLI, C_ITEM.CDFILLAN, C_ITEM.NRSOLICMP, :NEW.CDPRODUTO,
                         C_ITEM.DTPROGENTR, SYSDATE, V_CDOPERADOR, 0, :NEW.QTPROGENTAF,
                        'Atencin !!! La Solicitud de Compras ha cambiado el embalaje.');
               END LOOP;
            END IF;
         END IF;
      ELSE
         SELECT NVL(MAX(IDPRCMPATIVO), 'N'), NVL(MAX(CDPRODESTO), '1')
           INTO V_IDPRCMPATIVO, V_CDPRODESTO
           FROM PRODUTO
          WHERE CDPRODUTO = :OLD.CDPRODUTO;
         IF V_IDPRCMPATIVO = 'N' THEN
            SELECT NVL(MAX(PRODUTOOL.VRFATOCONV), 0), MAX(PRODUTO.CDPRODUTO), CASE NVL(MAX(PRODUTOOL.VRARREDCMP), 0)
                                                                                 WHEN 0
                                                                                 THEN 1
                                                                                 ELSE NVL(MAX(PRODUTOOL.VRARREDCMP), 0)
                                                                              END, CASE NVL(MAX(PRODUTO.VRFATOCONV), 0)
                                                                                      WHEN 0
                                                                                      THEN 1
                                                                                      ELSE NVL(MAX(PRODUTO.VRFATOCONV), 0)
                                                                                   END
              INTO V_VRFATOCONVOL, V_CDPRODUTOORIG, V_VRARREDCMPOL, V_VRFATOCONVORIG
              FROM RELACPRODOL, PRODUTO, PRODUTO PRODUTOOL
             WHERE RELACPRODOL.CDPRODARVOL = :OLD.CDPRODUTO
               AND RELACPRODOL.CDMARCA     = :OLD.CDMARCA
               AND RELACPRODOL.CDPRARVORIG = PRODUTO.CDPRODUTO
               AND RELACPRODOL.CDPRODARVOL = PRODUTOOL.CDPRODUTO
               AND PRODUTO.CDPRODESTO      = PRODUTOOL.CDPRODESTO
               AND RELACPRODOL.CDPRARVORIG <> RELACPRODOL.CDPRODARVOL;
               --AND NVL(PRODUTO.IDPRCMPATIVO, 'N')  = 'S'

            V_QTSOLIPROD := :OLD.QTPROGENTAF*V_VRFATOCONVOL;
            V_QTSOLIPROD := CEIL(V_QTSOLIPROD/V_VRFATOCONVORIG);


            FOR C_ITEM IN (SELECT CDFILSOLI, CDFILLAN, NRSOLICMP, CDPRODUTO, DTPROGENTR
                            FROM ITEMSOLI
                           WHERE ITEMSOLI.CDFILSOLI  = :OLD.CDFILDEST
                             AND ITEMSOLI.CDPRODUTO  = :OLD.CDPRODUTO
                             AND ITEMSOLI.DTPROGENTR = :OLD.DTENTRITMSOL
                             AND ROWNUM = 1) LOOP
              BEGIN
                 INSERT
                   INTO ITEMSOLI (CDFILSOLI, CDFILLAN, NRSOLICMP, CDPRODUTO, DTPROGENTR, QTSOLIPROD,
                                  DTUTILIZA, IDITMCONS, TXOBSITMSOL, IDBAIXITMSOL, QTTRANSFSOL, NRLOTEESTQ,
                                  NRSUBLOTE, CDPRODPROD, CDFILLANCONS, CDFILSOLCONS, NRSOLCMPCONS,
                                  CDPRODUTCONS, DTPROGENCONS, CDMARCA)
                 SELECT CDFILSOLI, CDFILLAN, NRSOLICMP, V_CDPRODUTOORIG, DTPROGENTR, V_QTSOLIPROD,
                        DTUTILIZA, IDITMCONS, TXOBSITMSOL, IDBAIXITMSOL, QTTRANSFSOL, NRLOTEESTQ,
                        NRSUBLOTE, CDPRODPROD, CDFILLANCONS, CDFILSOLCONS, NRSOLCMPCONS,
                        CDPRODUTCONS, DTPROGENCONS, CDMARCA
                   FROM ITEMSOLI
                  WHERE ITEMSOLI.CDFILSOLI  = C_ITEM.CDFILSOLI
                    AND ITEMSOLI.CDFILLAN   = C_ITEM.CDFILLAN
                    AND ITEMSOLI.NRSOLICMP  = C_ITEM.NRSOLICMP
                    AND ITEMSOLI.CDPRODUTO  = C_ITEM.CDPRODUTO
                    AND ITEMSOLI.DTPROGENTR = C_ITEM.DTPROGENTR;
              EXCEPTION
                 WHEN OTHERS THEN BEGIN
                    UPDATE ITEMSOLI
                       SET QTSOLIPROD    = QTSOLIPROD + V_QTSOLIPROD
                     WHERE ITEMSOLI.CDFILSOLI  = C_ITEM.CDFILSOLI
                       AND ITEMSOLI.CDFILLAN   = C_ITEM.CDFILLAN
                       AND ITEMSOLI.NRSOLICMP  = C_ITEM.NRSOLICMP
                       AND ITEMSOLI.CDPRODUTO  = V_CDPRODUTOORIG
                       AND ITEMSOLI.DTPROGENTR = C_ITEM.DTPROGENTR;
                 END;
              END;
              /******************************
              PARA HOMOLOGAR NA 6.35
              ***************SCRIPT ****************

               ALTER TABLE ITEMSOLIRELACAF DROP
  	                   CONSTRAINT  FKCMP00594ITEMAUTF
              ******************************************/


              /***********IMPLEMENTACAO NECESSRIA PARA 6.35
              DELETE
                FROM ITEMSOLIRELACAF
               WHERE ITEMSOLIRELACAF.CDFILSOLI  = C_ITEM.CDFILSOLI
                 AND ITEMSOLIRELACAF.CDFILLAN   = C_ITEM.CDFILLAN
                 AND ITEMSOLIRELACAF.NRSOLICMP  = C_ITEM.NRSOLICMP
                 AND ITEMSOLIRELACAF.CDPRODUTO  = V_CDPRODUTOORIG
                 AND ITEMSOLIRELACAF.DTPROGENTR = C_ITEM.DTPROGENTR;
                ************************/ 

              DELETE
                FROM ITEMSOLI
               WHERE ITEMSOLI.CDFILSOLI  = C_ITEM.CDFILSOLI
                 AND ITEMSOLI.CDFILLAN   = C_ITEM.CDFILLAN
                 AND ITEMSOLI.NRSOLICMP  = C_ITEM.NRSOLICMP
                 AND ITEMSOLI.CDPRODUTO  = C_ITEM.CDPRODUTO
                 AND ITEMSOLI.DTPROGENTR = C_ITEM.DTPROGENTR;

              NMUSUARIO(V_NMOPERADOR);
              SELECT MAX(CDOPERADOR)
                INTO V_CDOPERADOR
                FROM OPERADOR
               WHERE NMOPERADOR = V_NMOPERADOR;
              INSERT
               INTO MOVOPSOL (CDFILSOLMOV, CDFILLANMOV, NRSOLIMOV, CDPRODUTO,
                              DTENTROPER, DTOPERSOL, CDOPERADOR, QTANTOPER, QTDEPOPER,
                              DSJUSTOPER)
              VALUES (C_ITEM.CDFILSOLI, C_ITEM.CDFILLAN, C_ITEM.NRSOLICMP, V_CDPRODUTOORIG,
                     C_ITEM.DTPROGENTR, SYSDATE, V_CDOPERADOR, 0, V_QTSOLIPROD,
                    'Atencin !!! La Solicitud de Compras ha cambiado el embalaje.');
            END LOOP;
         END IF;
      END IF;
   ELSE
      IF INSERTING THEN
         :NEW.QTPROGENTAF := CEIL(:NEW.QTPROGENTAF);
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_ATUALIZA_QTPROGENTAF_OL','6.35.028'); END;
/

