/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPOCIA                                                  */
/* Tabela : TIPOCIA                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TIPOCIA' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_TIPOCIA
GO

CREATE TRIGGER DTULTATU_TIPOCIA
ON TIPOCIA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TIPOCIA', null, 'CDTPCIA='+ CDTPCIA+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TIPOCIA
      SET DTULTATUTCIA = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(TIPOCIA.CDTPCIA,0) = ISNULL(INSERTED.CDTPCIA,0)) AND
            (ISNULL(TIPOCIA.DSTPCIA,0) = ISNULL(INSERTED.DSTPCIA,0));
   END;
END;
GO

