CREATE TABLE CAMPCOMPGANHE(
   CDCAMPCOMPGANHE VARCHAR2(10) NOT NULL,
   DSCAMPCOMPGANHE VARCHAR2(50) NOT NULL,
   QTCOMPGANHE     FLOAT        NOT NULL,
   NRORG           NUMBER 	DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
   IDATIVO         VARCHAR2(1) 	DEFAULT 'S' NOT NULL
      CONSTRAINT CKC_IDATIVO_CAMPCOMPGANHE CHECK (IDATIVO IN ('S','N')),
   DTINCLUSAO 	   DATE 	NULL,
   DTULTATU        DATE 	NULL,
   NRORGINCLUSAO   NUMBER 	DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
   CDOPERINCLUSAO  VARCHAR2(12) DEFAULT '1' NULL,
   NRORGULTATU 	   NUMBER 	DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
   CDOPERULTATU    VARCHAR2(12) DEFAULT '1',
   CONSTRAINT PK_CAMPCOMPGANHE PRIMARY KEY (CDCAMPCOMPGANHE)
)
/

CREATE TABLE VGCAMPCOMPGANHE (
   CDCAMPCOMPGANHE VARCHAR2(10) NOT NULL,
   DTINIVGCAMPCG   DATE         NOT NULL,
   DTFINVGCAMPCG   DATE         NOT NULL,
   NRORG           NUMBER 	DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
   IDATIVO         VARCHAR2(1) 	DEFAULT 'S' NOT NULL
      CONSTRAINT CKC_IDATIVO_VGCAMPCOMPGANHE CHECK (IDATIVO IN ('S','N')),
   DTINCLUSAO 	   DATE 	NULL,
   DTULTATU        DATE 	NULL,
   NRORGINCLUSAO   NUMBER 	DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
   CDOPERINCLUSAO  VARCHAR2(12) DEFAULT '1' NULL,
   NRORGULTATU 	   NUMBER 	DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
   CDOPERULTATU    VARCHAR2(12) DEFAULT '1',
   CONSTRAINT PK_VGCAMPCOMPGANHE PRIMARY KEY (CDCAMPCOMPGANHE, DTINIVGCAMPCG)
)
/

CREATE INDEX VND00781_FK ON VGCAMPCOMPGANHE (CDCAMPCOMPGANHE ASC)
/

ALTER TABLE VGCAMPCOMPGANHE
   ADD CONSTRAINT FKVND00781CAMPCOMPGANHE FOREIGN KEY (CDCAMPCOMPGANHE)
      REFERENCES CAMPCOMPGANHE (CDCAMPCOMPGANHE)
/

CREATE TABLE PRCAMPCOMPGANHE (
   CDCAMPCOMPGANHE VARCHAR2(10) NOT NULL,
   DTINIVGCAMPCG   DATE         NOT NULL,
   CDPRODUTO       VARCHAR2(10) NOT NULL,
   NRORG           NUMBER 	DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
   IDATIVO         VARCHAR2(1) 	DEFAULT 'S' NOT NULL
      CONSTRAINT CKC_IDATIVO_PRCAMPCOMPGANHE CHECK (IDATIVO IN ('S','N')),
   DTINCLUSAO 	   DATE 	NULL,
   DTULTATU        DATE 	NULL,
   NRORGINCLUSAO   NUMBER 	DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
   CDOPERINCLUSAO  VARCHAR2(12) DEFAULT '1' NULL,
   NRORGULTATU 	   NUMBER 	DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
   CDOPERULTATU    VARCHAR2(12) DEFAULT '1',
   CONSTRAINT PK_PRCAMPCOMPGANHE PRIMARY KEY (CDCAMPCOMPGANHE, DTINIVGCAMPCG, CDPRODUTO)
)   
/

CREATE INDEX VND00782_FK ON PRCAMPCOMPGANHE (CDCAMPCOMPGANHE ASC, DTINIVGCAMPCG ASC)
/

ALTER TABLE PRCAMPCOMPGANHE
   ADD CONSTRAINT FKVND00782VGCAMPCOMPGANHE FOREIGN KEY (CDCAMPCOMPGANHE, DTINIVGCAMPCG)
      REFERENCES VGCAMPCOMPGANHE (CDCAMPCOMPGANHE, DTINIVGCAMPCG)
/

CREATE INDEX VND00783_FK ON PRCAMPCOMPGANHE (CDPRODUTO ASC)
/

ALTER TABLE PRCAMPCOMPGANHE
   ADD CONSTRAINT FKVND00783PRODUTO FOREIGN KEY (CDPRODUTO)
      REFERENCES PRODUTO (CDPRODUTO)
/

CREATE TABLE FICAMPCOMPGANHE (
   CDCAMPCOMPGANHE VARCHAR2(10) NOT NULL,
   CDFILIAL        VARCHAR2(4)  NOT NULL,
   NRORG           NUMBER 	DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
   IDATIVO         VARCHAR2(1) 	DEFAULT 'S' NOT NULL
      CONSTRAINT CKC_IDATIVO_FICAMPCOMPGANHE CHECK (IDATIVO IN ('S','N')),
   DTINCLUSAO 	   DATE 	NULL,
   DTULTATU        DATE 	NULL,
   NRORGINCLUSAO   NUMBER 	DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
   CDOPERINCLUSAO  VARCHAR2(12) DEFAULT '1' NULL,
   NRORGULTATU 	   NUMBER 	DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
   CDOPERULTATU    VARCHAR2(12) DEFAULT '1',
   CONSTRAINT PK_FICAMPCOMPGANHE PRIMARY KEY (CDCAMPCOMPGANHE, CDFILIAL)
)
/

CREATE INDEX VND00784_FK ON FICAMPCOMPGANHE (CDCAMPCOMPGANHE ASC)
/

ALTER TABLE FICAMPCOMPGANHE
   ADD CONSTRAINT FKVND00784CAMPCOMPGANHE FOREIGN KEY (CDCAMPCOMPGANHE)
      REFERENCES CAMPCOMPGANHE (CDCAMPCOMPGANHE)
/

CREATE INDEX VND00785_FK ON FICAMPCOMPGANHE (CDFILIAL ASC)
/

ALTER TABLE FICAMPCOMPGANHE
   ADD CONSTRAINT FKVND00785FILIAL FOREIGN KEY (CDFILIAL)
      REFERENCES FILIAL (CDFILIAL)
/

ALTER TABLE ITEMVENDA ADD CDCAMPCOMPGANHE VARCHAR2(10) NULL
/

ALTER TABLE ITEMVENDA ADD DTINIVGCAMPCG DATE NULL
/

CREATE INDEX VND00786_FK ON ITEMVENDA (CDCAMPCOMPGANHE ASC, DTINIVGCAMPCG ASC)
/

ALTER TABLE ITEMVENDA
   ADD CONSTRAINT FKVND00786VGCAMPCOMPGANHE FOREIGN KEY (CDCAMPCOMPGANHE, DTINIVGCAMPCG)
      REFERENCES VGCAMPCOMPGANHE (CDCAMPCOMPGANHE, DTINIVGCAMPCG)
/

ALTER TABLE ITCOMANDAVEN ADD CDCAMPCOMPGANHE VARCHAR2(10) NULL
/

ALTER TABLE ITCOMANDAVEN ADD DTINIVGCAMPCG DATE NULL
/